package fr.uca.iut.urbandictionarylight.model

import fr.uca.iut.urbandictionarylight.utils.Sorting

class Entry(val phrase: String) {
    private val definitions: MutableSet<Definition> = mutableSetOf()

    fun createDefinition(definition: Definition) {
        if (definition.content.isNotBlank() && definition.example.isNotBlank()) {
            definitions.add(definition)
        }
    }

    fun readDefinition(id: Int): Definition {
        // TODO implement once ORM is in place
        return Definition(
            content = "poopy butt",
            example = "Yeah, that's right -- poopy butt. This method hasn't been implemented yet."
        )
    }

    fun readAllDefinitions() = definitions.toSet()

    // TODO implement
    fun readAllDefinitions(criterion: Sorting): Set<Definition> {
        when (criterion) {
            Sorting.ASC -> {
                print("implement asc sorting!")
                return readAllDefinitions()
            }
            Sorting.DESC -> {
                print("implement desc sorting!")
                return readAllDefinitions()
            }
            else -> return readAllDefinitions()
        }
    }

    fun updateDefinition(definition: Definition) {
        // TODO implement once ORM is in place
//        removeDefinition(definition.id)
        createDefinition(definition)
    }

    // TODO throw this away soon
    fun updateDefinition(old: Definition, new: Definition) {
        deleteDefinition(old)
        createDefinition(new)
    }

    fun deleteDefinition(definition: Definition) {
        definitions.remove(definition)
    }

    fun deleteDefinition(id: Int) {
        // TODO implement once ORM is in place
//        definitions.removeIf { def -> id == def.id }
    }

    // TODO redefine equals and hashset
}